from wssiham.app.pec_doctorant.classes.gateway import Gateway

import logging
import typer

logger = logging.getLogger(__name__)
app = typer.Typer()


@app.command()
def doctorant(fichier: str = typer.Argument(..., help="Fichier excel des doctorants"),
              repertoire: str = typer.Option(..., "--output", "-o", help="Répertoire de sortie contenant les rapports"),
              date_debut_pec: str = typer.Option(..., "--date-debut-pec",
                                                 help="Date début utilisée pour la pec "
                                                      "(date embauche, date effet statut, position...)."
                                                      "Format utilisé dd/mm/yyyy"),
              date_fin_pec: str = typer.Option(..., "--date-fin-pec",
                                               help="Date fin utilisée pour la pec "
                                                    "(date embauche, date effet statut, position...)."
                                                    "Format utilisé dd/mm/yyyy"),
              simulation: bool = typer.Option(False, "-s", "--simulation", help="Active/désactive la simulation, "
                                                                                "càd que les données ne seront pas "
                                                                                "injectés dans SIHAM. Par défaut,"
                                                                                "la simulation est activée")):

    gtw = Gateway(path=fichier, output_directory=repertoire, start_date_employment=date_debut_pec,
                  end_date_employment=date_fin_pec)
    gtw.process(simulation)

@app.callback()
def main() -> None:
    """Gestion des doctorants"""
    pass
