from pydantic import BaseModel, conint, conlist, constr
from typing import Optional
from datetime import datetime


class Adresse(BaseModel):
    """
    Modèle représentant une adresse.
    """
    bisTerAdresse: Optional[str]
    codeDepartementAdresse: Optional[str]
    codePostalAdresse: Optional[str]
    codeTypologieAdresse: Optional[str]
    dateDebutAdresse: Optional[datetime]
    libLongTypologieAdresse: str
    matricule: Optional[str]
    natureVoieAdresse: Optional[str]
    noVoieAdresse:Optional[str]
    nomVoieAdresse: Optional[str]


class AdresseDAD(Adresse):
    ligneAdresseVoieText: Optional[str]
    ligneAdresseVoie: Optional[str]
    ligneAdresseDestination: Optional[str]
    libLongPaysISOAdresse: Optional[str]
    libLongDepartementAdresse: Optional[str]
    complementAdresse: Optional[str]
    communeEtatAdresse: Optional[str]
    bureauDistributeurAdresse: Optional[str]
    codePaysINSEEAdresse: Optional[str]
    codePaysISOAdresse: Optional[str]
    temAdressePrincipale: Optional[str]


class AdresseHeberge(Adresse):
    villeAdresse: Optional[str]
    codePaysAdresse: Optional[str]
    libLongPaysAdresse: Optional[str]


class AdresseDAP(Adresse):
    temAdressePrincipale: Optional[str]
    ligneAdresseVoieText: Optional[str]
    ligneAdresseVoie: Optional[str]
    complementAdresse: Optional[str]
    codePaysINSEEAdresse: Optional[str]
    bureauDistributeurAdresse: Optional[str]
    ligneAdresseDestination: Optional[str]
    communeEtatAdresse: Optional[str]
    libLongDepartementAdresse: Optional[str]
    codePaysISOAdresse: Optional[str]
    libLongPaysAdresse: Optional[str]
