from pydantic import BaseModel, constr, Field
from typing import Optional
from datetime import datetime


class InformationAgentBase(BaseModel):
    matricule: constr(max_length=15)
    userId: Optional[str] = Field(default=None)


class InformationAgentEcheance(InformationAgentBase):
    temEtat: constr(max_length=1)
    temRetraite: constr(max_length=1)


class InformationAgentModifie(InformationAgentBase):
    pass


class InformationAgent(InformationAgentBase):
    """
    Modèle représentant les données personnelles d'une personne.
    """
    codeCivilite: constr(max_length=1)
    dateNaissance: datetime
    nomPatronymique: Optional[str]
    nomUsuel: str
    prenom: str


class InformationAgentLA(InformationAgent):
    """
    Modèle représentant les données personnelles d'une personne.
    """
    codeEmploiAffectationHierarchique: Optional[str]
    codeEtablissement: str
    codePosteAffectation: Optional[str]
    codeUOAffectationHierarchique: Optional[str]
    dateDebutAffectHierarchique: Optional[datetime]
    dateFinAffectHierarchique: Optional[datetime]
    faxPro: Optional[str]
    libLongCivilite: str
    libLongEmploiAffectation: Optional[str]
    libLongPosteAffectation: Optional[str]
    libLongUOAffectationHierarchique: Optional[str]
    mailPro: Optional[str]
    numDossierHarpege: Optional[str]
    numeroInseeDefinitif: Optional[constr(max_length=15)]
    numeroInseeProv: Optional[str]
    portablePro: Optional[str]
    quotiteAffectHierarchique: Optional[str]
    telephonePro: Optional[str]


class InformationAgentMA(InformationAgent):
    categorieStatutaire: Optional[str]
    codeEmploiAffectation: Optional[str]
    codePIP: str
    codePosteAffectation: Optional[str]
    codeUOAffectation: str
    dateDebutAffectation: datetime
    dateDepart: Optional[datetime]
    dateFinAffectation: Optional[datetime]
    libCivilite: str
    libLongCategorieStatutaire: Optional[str]
    libLongEmploiAffectation: str
    libLongPIP: str
    libLongPosteAffectation: Optional[str]
    libLongUOAffectation: str
    motifDepart: Optional[str]
    quotiteAffectation: str