from pydantic import BaseModel, Field
from datetime import datetime
from typing import Optional

class ParamMatricule(BaseModel):
    matricule: str


class ParamAbsenceConges(BaseModel):
    codeAbsenceConges: str                                      # ZYAG.MOTIFA


class ParamAffectationUO(BaseModel):
    codeUO: Optional[str] = Field(default='')                   # ZY3C.IDOU00
    temoinUOFille: Optional[str] = Field(default='')            # 0 sans héritage, 1 avec héritage
    typeLienAffectationUO: Optional[str] = Field(default='')    # ZY3C.TYTRST HIE, FUN, ADR


class ParamCorps(BaseModel):
    codeCorps: str                                              # ZYGR.CORPS


class ParamFonction(BaseModel):
    codeFonction: Optional[str] = Field(default='')             # ZYV1.TYPFON
    codeTypefonction: Optional[str] = Field(default='')         # ZYV1.FONCTI


class ParamGrades(BaseModel):
    codeGrade: str                                              # ZYGR.ADECOD


class ParamGroupeHierarchique(BaseModel):
    codeGroupeHierarchique: str                                 # ZYGR.ADECOD


class ParamModaliteService(BaseModel):
    codeModaliteService: str                                    # ZYTL.CODTRA (MS100 ...)


class ParamPIP(BaseModel):
    codePIP: str                                                # ZYFL.STATUT


class ParamPositionsAdministratives(BaseModel):
    codePositionAdministrative: str                             # ZYPO.SITCOD (ACI01, FINAC, ...)


class ParamQualitesStatutaires(BaseModel):
    codeQualiteStatutaire: str                                  # ZYGR.QUALIT (N: Non Titulaire, T: Titulaire)


class ParamResponsHierarchiqUO(BaseModel):
    codeUOresponsable: str                                      # ZE00.IDOU00


class ParamTypeContrat(BaseModel):
    codeTypeContrat: Optional[str] = Field(default='')          # ZYOC.TYPCON
    modeGest: Optional[str] = Field(default='')                 # ZYOC.MODGST


class ParamSpecialitesNiv1Agent(BaseModel):
    codeSpecialiteNiv1Agt: Optional[str] = Field(default='')    # ZYVS.SPECIA
    codeTypeSpecialiteAgent: Optional[str] = Field(default='')  # ZYVS.TYPSPE
    temoinHeritage: Optional[str] = Field(default='')           # ZYVS.HERITA


class ParamCarriere(BaseModel):
    chevron: Optional[str] = Field(default='')                  # ZYGR.CHEVRO
    dateEffetCarriere: datetime = Field(default='')             # ZYGR.DATEFF
    dateFin: Optional[datetime] = Field(default='')             # ZYGR.DATFI
    echelon: str                                                # ZYGR.ECHELO
    grade: str                                                  # ZYGR.ADECOD
    indiceBrut: Optional[str] = Field(default='')               # ZYGR.INDBRU
    indiceMajore: Optional[str] = Field(default='')             # ZYGR.INDMAJ
    modeAccesEchelon: Optional[str] = Field(default='')         # ZYGR.MODECH
    modeAccesGrade: Optional[str] = Field(default='')           # ZYGR.MODACC
    numCarriere: Optional[str] = Field(default='')              # ZYGR.NUMCAR
    numord: Optional[str] = Field(default='')                   # ZYGR.NUMORD
    qualiteStatutaire: Optional[str] = Field(default='')        # ZYGR.QUALIT
    temRemAcessoire: Optional[str] = Field(default='')          # ZYGR.FLGVAC
    temoinValidite: Optional[str] = Field(default='')           # ZYGR.VALIDE


class ParamContrats(BaseModel):
    chevron: Optional[str] = Field(default='')                      # ZYCO.CHEVRO
    commentaireContrat: Optional[str] = Field(default='')           # ZYCO.COMENT
    dateDebutContrat: datetime                                      # ZYCO.DATCON
    dateFinContrat: Optional[datetime] = Field(default='')          # ZYCO.DATFIN
    debutPeriodeEssai: Optional[datetime] = Field(default='')       # ZYCO.DEBESS
    deviseRemunerationContrat: Optional[str] = Field(default='')    # ZYCO.VABUC
    finPeriodeEssai: Optional[str] = Field(default='')              # ZYCO.FINESS
    gradeTG: Optional[str] = Field(default='')                      # ZYCO.PSGRNE
    horsEchelleLettre: Optional[str] = Field(default='')            # ZYCO.IDHEL0
    indiceRemu: Optional[str] = Field(default='')                   # ZYCO.IDREM0
    modeDeGestion: Optional[str] = Field(default='')                # ZYCO.MODGST
    modeRemuneration: Optional[str] = Field(default='')             # ZYCO.MODREM
    natureContrat: Optional[str] = Field(default='')                # ZYCO.NATCON
    nbHeuresContrat: Optional[str] = Field(default='')              # ZYCO.NBRHEU
    pourcentage: Optional[int] = Field(default='')                  # ZYCO.RTGR00
    remunerationContrat: Optional[int] = Field(default='')          # ZYCO.VABUC
    tauxHoraires: Optional[float] = Field(default='')               # ZYCO.TAUXHO
    temoinValidite: Optional[str] = Field(default='')               # ZYCO.VALIDE
    typeContrat: str                                                # ZYCO.TYPCON
    typeLienJuridique: str                                          # ZYCO.TYJBLJ


class ParamCoordonneesPostales(BaseModel):
    bisTer: Optional[str] = Field(default='')                       # ZY0F.BISTFR
    bureauDistributeur: str                                         # ZY0F.BURDFR
    INSEFR: Optional[str] = Field(default='')
    codePays: str                                                   # ZY0F.CDPAYS
    codePostal: str                                                 # ZY0F.CPOSFR
    commune: Optional[str] = Field(default='')                      # ZY0F.COMMFR
    complementAdresse: Optional[str] = Field(default='')            # ZY0F.CPADFR
    debutAdresse: datetime                                          # ZY0F.DATDEB
    finAdresse: Optional[datetime] = Field(default='')              # ZY0F.DATFIN
    natureVoie: Optional[str] = Field(default='')                   # ZY0F.NATVOI
    nomVoie: Optional[str] = Field(default='')                      # ZY0F.VOIEFG
    numAdresse: Optional[str] = Field(default='')                   # ZY0F.NUMVFR
    temAdressePrincipale: str                                       # ZY0F.TEMADD
    temoinValidite: Optional[str] = Field(default='')               # ZY0F.VALIDE
    typeAdresse: str                                                # ZY0F.TYPADD / ZD UAD


class ParamCoordonneesBancaires(BaseModel):
    cleCompte: str                                                  # ZY0I.CPTFIN
    codeAgence: str                                                 # ZY0I.AGENFR
    codeBanque: str                                                 # ZY0I.BANQFR
    dateDebBanque: datetime                                         # ZY0I.DATDEB
    dateFinBanque: Optional[datetime] = Field(default='')           # ZY0I.DATFIN
    IBAN: Optional[str] = Field(default='')                         # ZY0I.CPIBAN
    libelleAgence: str                                              # ZY0I.LIBBAN
    modePaiement: str                                               # ZY0I.MODPAI
    numCompte: str                                                  # ZY0I.CPTE11
    paysBanque: str                                                 # ZY0I.CDPAYS
    SWIFT: Optional[str] = Field(default='')                        # ZY0I.SWIFT
    temoinValidite: Optional[str] = Field(default='')               # ZY0I.VALIDE


class ParamModalitesServicesPEC(BaseModel):
    dateEffetModalite: datetime                                     # ZYTL.DATEFF
    modalite: str                                                   # ZYTL.CODTRA
    temoinValidite: Optional[str] = Field(default='')               # ZYTL.VALIDE


class ParamNationalites(BaseModel):
    modeAcquisitionNationalite: Optional[str] = Field(default='')   # ZY12.IDNA00
    nationalite: str                                                # ZY12.NATION
    temPrincipale: Optional[str] = Field(default='')                # ZY12.VALIDE


class ParamNumerosTelephone(BaseModel):
    dateDebutTel: datetime                                          # ZY0H.DATDEB
    numero: str                                                     # ZY0H.NUMTEL
    typeNumero: str                                                 # ZY0H.TYPTEL


class ParamPostions(BaseModel):
    dateEffetPosition: datetime                                     # ZYPO.DATEFF
    dateFinPrevue: Optional[datetime] = Field(default='')           # ZYPO.FINPRE
    dateFinReelle: Optional[datetime] = Field(default='')           # ZYPO.FINRRE
    position: str                                                   # ZYPO.SITCOD
    temoinValidite: Optional[str] = Field(default='')               # ZYPO.VALIDE


class ParamStatuts(BaseModel):
    dateEffetStatut: datetime                                       # ZYFL.DATEFF
    statut: str                                                     # ZYFL.STATUT
    temoinValidite: Optional[str] = Field(default='')               # ZYFL.VALIDE


class ParamSituationsFamiliales(BaseModel):
    dateEffetSituFam: Optional[datetime] = Field(default='')        # ZY18.DATSIT
    situFam: str                                                    # ZY18.SITFAM
    temoinValidite: Optional[str] = Field(default='')               # ZY18.VALIDE
