import typer


class TyperExtend:

    @staticmethod
    def breakline() -> None:
        typer.echo()

    @staticmethod
    def exit_unsuccess() -> None:
        raise typer.Exit(code=1)

    @staticmethod
    def exit_success() -> None:
        typer.Exit(code=0)

    @staticmethod
    def header_echo(message: str) -> None:
        typer.secho(message, fg=typer.colors.WHITE)

    @staticmethod
    def valid_echo(message: str) -> None:
        typer.secho(f'   {typer.style("[+]", fg=typer.colors.GREEN)} {message}')

    @staticmethod
    def error_echo(message: str) -> None:
        typer.secho(f'   {typer.style("[-]", fg=typer.colors.RED)} {message}')

    @staticmethod
    def info_echo(message: str) -> None:
        flag = f'/!{chr(92)}'
        typer.secho(f'   {typer.style(flag, fg=typer.colors.YELLOW)} {message}')

    @staticmethod
    def simple_echo(message: str) -> None:
        typer.secho(f'{message}')

    @classmethod
    def header_script(cls, nom_script: str, description: str) -> None:
        cls.header_echo('###################################################################')
        cls.header_echo(f'#Nom du script  : {typer.style(f"{nom_script}", fg=typer.colors.MAGENTA)}')
        cls.header_echo(f'#Description    : {description}')
        cls.header_echo('#Auteur       	: Christophe Damour')
        cls.header_echo('#Email         	: christophe.damour@univ-reunion.fr')
        cls.header_echo('###################################################################')